



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Angularjs判断页面是否已经渲染结束（动态给标签长度）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Angularjs判断页面是否已经渲染结束（动态给标签长度）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-15 04:33:32 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>相信大家都会碰到这样的问题。页面循环li。但是因为个数不知道。没有办法给li设置固定宽度。那么这时就需要动态计算数据长度并动态改变li的宽度</p>
<div>
<pre class="prettyprint linenums"> &lt;!--周边信息--&gt;<br />
         &lt;div class="around_information"&gt;<br />
             &lt;div class="title_info"&gt;<br />
                 &lt;i&gt;&lt;/i&gt;<br />
                 &lt;p&gt;周边信息&lt;/p&gt;<br />
             &lt;/div&gt;<br />
             &lt;div class="around_info"&gt;<br />
                 &lt;div class="around_table"&gt;<br />
                     &lt;ul&gt;<br />
                         &lt;li class="aroundLength" ng-repeat="data in aroundInfoData"on-finish-render-filters&gt;<br />
                             &lt;label&gt;{{data.aroundName}}&lt;/label&gt;<br />
                             &lt;p&gt;{{data.aroundNum}}&lt;/p&gt;<br />
                         &lt;/li&gt;<br />
                     &lt;/ul&gt;<br />
                 &lt;/div&gt;<br />
             &lt;/div&gt;<br />
         &lt;/div&gt; </pre>
</div>
<p>&lt;li&gt;&lt;/li&gt;可以默认给个固定宽度，当然不给也是完全OK的</p>
<p>控制器中的数据信息：</p>
<pre class="prettyprint linenums">$scope.aroundInfoData =[{"aroundName":"所在商圈", "aroundNum":"李宁商圈"},<br />
    {"aroundName":"安踏", "aroundNum":"0"}, {"aroundName":"特步", "aroundNum":"1"},<br />
    {"aroundName":"361&deg;", "aroundNum":"0"},{"aroundName":"高中", "aroundNum":"3"},<br />
    {"aroundName":"耐克", "aroundNum":"0"},{"aroundName":"阿迪达斯", "aroundNum":"2"},<br />
    {"aroundName":"瑜伽馆", "aroundNum":"1"},{"aroundName":"大学", "aroundNum":"2"},<br />
    {"aroundName":"篮球馆", "aroundNum":"0"},{"aroundName":"健身房", "aroundNum":"0"}]</pre>
<p>json数据可以自己造。想造多少都可以</p>
<p>需要监听页面是否渲染结束。<a href="http://lib.csdn.net/base/angularjs" rel="external nofollow noreferrer">AngularJS</a>有$last是最后一个元素。用到指令</p>
<div>
<pre class="prettyprint linenums">app.directive('onFinishRenderFilters', function ($timeout) {<br />
    return {<br />
        restrict: 'A',<br />
        link: function(scope, element, attr) {<br />
            if (scope.$last === true) {<br />
                $timeout(function() {<br />
                    scope.$emit('ngRepeatFinished');<br />
                });<br />
            }<br />
        }<br />
    };<br />
});</pre>
</div>
<p>Controller里面用$on去监听</p>
<div>
<pre class="prettyprint linenums">$scope.$on('ngRepeatFinished', function (ngRepeatFinishedEvent) {<br />
        //监听页面渲染结束<br />
        $scope.showLength =$scope.aroundInfoData.length  //把实际需要展示数据的格式赋给showLength<br />
        var titleWidth = document.getElementsByClassName("aroundLength");<br />
        for(var i =0;i&lt;document.getElementsByClassName("aroundLength").length;i++){<br />
            document.getElementsByClassName("aroundLength")[i].style.width = (100/$scope.showLength)+"%";<br />
        }<br />
    });</pre>
</div>
<p>预期结果：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1187402/201706/1187402-20170622150124476-1861055377.png" /></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qwdv338.html">做一个java项目要经过那些正规的步骤</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyvkyjq.html">MySQL大小写补坑记</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8ogk6lq.html">Oracle对列的操作总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyxn128.html">Mac下同时安装多个版本的JDK</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8opd1xq.html">【JAVA网络流之TCP与UDP 】</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z7k5n9.html">5&lowbar;STL设计理念&lowbar;迭代器</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j7re09.html">学习OpenCV&mdash;&mdash;SVM 手写数字检测</a>
		</li>
						<li><a href="https://www.batexi.com/a/m9616j48.html">&lbrack;Cocos2d-x For WP8&rsqb;点击移动精灵</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdee54j9.html">&lbrack;转载&rsqb; 【每周推荐阅读】C-Store：列式存储数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o3ye39.html">&lbrack;leetcode&rsqb;&lowbar;Longest Common Prefix</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z136d19.html">IIS中使用PUT方法錯誤記錄</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o65vj9.html">VS2013 快捷键 与 RESHARPER 冲突</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zyole9.html">zoj2059（经典dp）</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yy6ln8.html">【Java技术位】&mdash;&mdash;代理模式及其事务包</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kppew59.html">android 推断应用程序是系统程序还是用户程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjlvkk8.html">Jquery下控制backgroundPosition位置的问题&sol;jquery查找data id相等的元素</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jyww38.html">Jquery&period;Uploadify实现批量上传显示进度条 取消 上传后缩略图显示 可删除</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1o7dmq.html">利用USearch去除嵌合体&lpar;chimeras&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy17wwmq.html">Spring Cloud &commat;HystrixCommand和&commat;CacheResult注解使用，参数配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gg50eq.html">【Java每日一题】20170321</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qnj342g8.html">神经网络3&lowbar;M-P模型</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gelkgl8.html">《Java》第四周学习总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/96p1grn8.html">Latex &amp;quot&semi;Error&colon; Extra alignment tab has been changed to &bsol;cr&period; &amp;quot&semi;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1pxegq.html">&lbrack;物理学与PDEs&rsqb;第2章习题7 一维不可压理想流体的求解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1xpzjq.html">获取reporting services导出pdf的url的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxk1ml08.html">print&lowbar;r print var&lowbar;dump echo区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/96p1r0v8.html">Lua中的userdata</a>
			</li>
						<li><a href="https://www.batexi.com/a/93y54pg8.html">mysql  迁移</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpm2o0q.html">&lbrack;JavaScript&rsqb;ECMA-6 yield语法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdzlj49.html">计算机基础 &amp;amp&semi; python基础</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
